/* Definitions for Emacs Lisp binding to Java Native Interface.
   Copyright (C) 2000 Daiki Ueno.

This file is part of XEmacs.

XEmacs is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

XEmacs is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with XEmacs; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef INCLUDED_java_h_
#define INCLUDED_java_h_ 1

#include <jni.h>

struct Lisp_JavaClass
{
  struct lcrecord_header header;
  jclass class;
  Lisp_Object name;
};
typedef struct Lisp_JavaClass Lisp_JavaClass;

DECLARE_EXTERNAL_LRECORD (javaclass, Lisp_JavaClass);

#define XJAVACLASS(x) XRECORD (x, javaclass, Lisp_JavaClass)
#define XSETJAVACLASS(x, p) XSETRECORD (x, p, javaclass)
#define JAVACLASSP(x) RECORDP (x, javaclass)
#define CHECK_JAVACLASS(x) CHECK_RECORD (x, javaclass)
#define CONCHECK_JAVACLASS(x) CONCHECK_RECORD (x, javaclass)

struct Lisp_JavaObject
{
  struct lcrecord_header header;
  jobject object;
  Lisp_Object signature;
};
typedef struct Lisp_JavaObject Lisp_JavaObject;

DECLARE_EXTERNAL_LRECORD (javaobject, Lisp_JavaObject);
#define XJAVAOBJECT(x) XRECORD (x, javaobject, Lisp_JavaObject)
#define XSETJAVAOBJECT(x, p) XSETRECORD (x, p, javaobject)
#define JAVAOBJECTP(x) RECORDP (x, javaobject)
#define CHECK_JAVAOBJECT(x) CHECK_RECORD (x, javaobject)
#define CONCHECK_JAVAOBJECT(x) CONCHECK_RECORD (x, javaobject)

#endif /* INCLUDED_java_h_ */
